/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __DEMUX_HEADER_INCLUDED__
#define __DEMUX_HEADER_INCLUDED__

#include <g_globals.h>
#include <s_globals.h>
#include <lists.h>

#define DEMUX_OK	0	/* This is the one */
#define DEMUX_UNKNOWN	-1	/* Didn't recognise the layer */
#define DEMUX_FINISHED	-2	/* This packet complete, skip all further steps */
/* If not these codes, then its a layer_type_t */

/* Threaded capdevs call this, it demultiplexes all layers  */
int demux( p_packet p );

/* Plugins register a bunch of these with us */
typedef int (*proc_demux)( p_packet p, int layer );

/* Plugins call this to add demux handlers  */
typedef uint (*proc_demux_add_handler) (uint, proc_demux);
uint demux_add_handler (uint layer, proc_demux target);

/* We maintain an array LAYERS_MAX of these lists*/
typedef struct demux_layer {
	list_head_t		l;
	proc_demux		demux;
}demux_layer_t, *p_demux_layer;

/* Init, plain and simple */
int demux_init(void);

#endif /* __DEMUX_HEADER_INCLUDED__ */
