/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef __RULES_HEADER_INCLUDED__
#define __RULES_HEADER_INCLUDED__
/* 
* RULES.H
* Managaes all installed ruleset parsers.
*/

#include <g_globals.h>
#include <packet.h>
#include <lists.h>

typedef int (*proc_parser_loadfile)(char *);

typedef struct parser {
	list_head_t		l;
	char			*name;
	proc_parser_loadfile	loadfile;
}parser_t, *p_parser;

int rules_init(void);

typedef int(*proc_add_parser)(char *, proc_parser_loadfile);

#ifndef __PLUGIN__
int rules_add_parser(char *, proc_parser_loadfile);
#endif

void rules_cleanup(int code, void *priv);
int rules_loadfile(char *type, char *fn);

#endif /* __RULES_HEADER_INCLUDED__ */
